import { MuClient } from '../client';
import { MuScheduler } from '../scheduler/scheduler';
export declare class MuClockClient {
    private _protocol;
    private _clock;
    private _pingInterval;
    private _delay;
    private _pingSamples;
    private _numPings;
    private _onTick;
    readonly tickRate: number;
    ping: number;
    maxPingSamples: number;
    skippedFrames: number;
    frameSkip: number;
    monotone: boolean;
    private _started;
    private _tickCount;
    private _pollHandle;
    private _poll;
    scheduler: MuScheduler;
    constructor(spec: {
        client: MuClient;
        ready?: () => void;
        tick?: (t: number) => void;
        pingRate?: number;
        pingBufferSize?: number;
        frameSkip?: number;
        enableRewind?: boolean;
        scheduler?: MuScheduler;
    });
    private _doPing;
    private _lastNow;
    private _simulationClock;
    poll(): void;
    now(): number;
    tick(): number;
}
