"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var protocol_1 = require("./protocol");
var stream_1 = require("../stream");
var MuDeltaClient = (function () {
    function MuDeltaClient(spec) {
        this._schema = spec.schema;
        this._protocol = spec.client.protocol(protocol_1.muDeltaSchema(spec.schema));
        this._state = spec.schema.clone(spec.schema.identity);
    }
    MuDeltaClient.prototype.configure = function (spec) {
        var _this = this;
        this._protocol.configure({
            message: {
                reset: function (state) {
                    _this._schema.assign(_this._state, state);
                    spec.change(state);
                },
            },
            raw: function (bytes) {
                if (typeof bytes === 'string') {
                    return;
                }
                var state = _this._schema.patch(_this._state, new stream_1.MuReadStream(bytes));
                _this._schema.assign(_this._state, state);
                spec.change(state);
                _this._schema.free(state);
            },
        });
    };
    return MuDeltaClient;
}());
exports.MuDeltaClient = MuDeltaClient;
//# sourceMappingURL=client.js.map