"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tcp = require("net");
function findPort(cb) {
    const server = tcp.createServer();
    server.on('error', (e) => console.error(e));
    server.unref();
    server.listen(() => {
        const addr = server.address();
        if (typeof addr === 'string') {
            server.close(() => cb(+addr));
        }
        else {
            const port = addr.port;
            server.close(() => cb(port));
        }
    });
}
exports.findPort = findPort;
function findPortAsync() {
    return new Promise((resolve) => {
        findPort(resolve);
    });
}
exports.findPortAsync = findPortAsync;
//# sourceMappingURL=port.js.map