"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function randBool() {
    return Math.random() >= 0.5;
}
exports.randBool = randBool;
function randInt(min, max) {
    return Math.random() * (max - min + 1) + min | 0;
}
exports.randInt = randInt;
function randInt8() {
    return randInt(-0x80, 0x7F);
}
exports.randInt8 = randInt8;
function randInt16() {
    return randInt(-0x8000, 0x7FFF);
}
exports.randInt16 = randInt16;
function randInt32() {
    return randInt(-0x80000000, 0x7FFFFFFF);
}
exports.randInt32 = randInt32;
function randUint8() {
    return randInt(0, 0xFF);
}
exports.randUint8 = randUint8;
function randUint16() {
    return randInt(0, 0xFFFF);
}
exports.randUint16 = randUint16;
function randUint32() {
    return randInt(0, 0xFFFFFFFF) >>> 0;
}
exports.randUint32 = randUint32;
const dv = new DataView(new ArrayBuffer(8));
function randFloat32() {
    let f;
    do {
        dv.setUint32(0, randUint32(), true);
        f = dv.getFloat32(0, true);
    } while (isNaN(f));
    return f;
}
exports.randFloat32 = randFloat32;
function randFloat64() {
    let f;
    do {
        dv.setUint32(0, randUint32(), true);
        dv.setUint32(4, randUint32(), true);
        f = dv.getFloat64(0, true);
    } while (isNaN(f));
    return f;
}
exports.randFloat64 = randFloat64;
//# sourceMappingURL=random.js.map